View Issue Details

IDProjectCategoryView StatusLast Update
0037186FPCRTLpublic2020-06-15 18:26
ReporterBi0T1N Assigned ToFlorian  
PrioritynormalSeverityminorReproducibilityalways
Status closedResolutionfixed 
Product Version3.3.1 
Fixed in Version3.3.1 
Summary0037186: [Patch] Wrong result type for QWord InterlockedCompareExchange64 function
DescriptionI assume that the result type should be qword as well.
TagsNo tags attached.
Fixed in Revision45647
FPCOldBugId
FPCTarget-
Attached Files

Activities

Bi0T1N

2020-06-07 22:17

reporter   ~0123319

Somehow it didn't uploaded the patch...
01-QWord_resulttype_for_unsigned_InterlockedCompareExchange64.patch (910 bytes)   
diff --git rtl/inc/systemh.inc rtl/inc/systemh.inc
index d455c4517c..cc720edb4d 100644
--- rtl/inc/systemh.inc
+++ rtl/inc/systemh.inc
@@ -1550,7 +1550,7 @@ function InterlockedIncrement64 (var Target: qword) : qword; external name 'FPC_
 function InterlockedDecrement64 (var Target: qword) : qword; external name 'FPC_INTERLOCKEDDECREMENT64';
 function InterlockedExchange64 (var Target: qword;Source : qword) : qword; external name 'FPC_INTERLOCKEDEXCHANGE64';
 function InterlockedExchangeAdd64 (var Target: qword;Source : qword) : qword; external name 'FPC_INTERLOCKEDEXCHANGEADD64';
-function InterlockedCompareExchange64(var Target: qword; NewValue: qword; Comperand: qword): int64; external name 'FPC_INTERLOCKEDCOMPAREEXCHANGE64';
+function InterlockedCompareExchange64(var Target: qword; NewValue: qword; Comperand: qword): qword; external name 'FPC_INTERLOCKEDCOMPAREEXCHANGE64';
 {$endif cpu64}
 
 

Florian

2020-06-13 21:14

administrator   ~0123419

Thanks, applied.

Issue History

Date Modified Username Field Change
2020-06-07 22:16 Bi0T1N New Issue
2020-06-07 22:17 Bi0T1N Note Added: 0123319
2020-06-07 22:17 Bi0T1N File Added: 01-QWord_resulttype_for_unsigned_InterlockedCompareExchange64.patch
2020-06-13 21:14 Florian Assigned To => Florian
2020-06-13 21:14 Florian Status new => resolved
2020-06-13 21:14 Florian Resolution open => fixed
2020-06-13 21:14 Florian Fixed in Version => 3.3.1
2020-06-13 21:14 Florian Fixed in Revision => 45647
2020-06-13 21:14 Florian FPCTarget => -
2020-06-13 21:14 Florian Note Added: 0123419
2020-06-15 18:26 Bi0T1N Status resolved => closed